searchData={"items":[{"type":"module","title":"ExAws.Operation.S3DeleteAllObjects","doc":"","ref":"ExAws.Operation.S3DeleteAllObjects.html"},{"type":"type","title":"ExAws.Operation.S3DeleteAllObjects.t/0","doc":"","ref":"ExAws.Operation.S3DeleteAllObjects.html#t:t/0"},{"type":"module","title":"ExAws.S3","doc":"[![CI](https://github.com/ex-aws/ex_aws_s3/workflows/on-push/badge.svg)](https://github.com/ex-aws/ex_aws_s3/actions?query=workflow%3Aon-push)\n[![Module Version](https://img.shields.io/hexpm/v/ex_aws_s3.svg)](https://hex.pm/packages/ex_aws_s3)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ex_aws_s3/)\n[![Total Download](https://img.shields.io/hexpm/dt/ex_aws_s3.svg)](https://hex.pm/packages/ex_aws_s3)\n[![License](https://img.shields.io/hexpm/l/ex_aws_s3.svg)](https://github.com/ex-aws/ex_aws_s3/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/ex-aws/ex_aws_s3.svg)](https://github.com/ex-aws/ex_aws_s3/commits/master)\n\nService module for https://github.com/ex-aws/ex_aws","ref":"ExAws.S3.html"},{"type":"module","title":"Installation - ExAws.S3","doc":"The package can be installed by adding `:ex_aws_s3` to your list of dependencies in `mix.exs`\nalong with `:ex_aws`, your preferred JSON codec / HTTP client, and optionally `:sweet_xml`\nto support operations like `list_objects` that require XML parsing.\n\n```elixir\ndef deps do\n  [\n    {:ex_aws, \"~> 2.0\"},\n    {:ex_aws_s3, \"~> 2.0\"},\n    {:poison, \"~> 3.0\"},\n    {:hackney, \"~> 1.9\"},\n    {:sweet_xml, \"~> 0.6.6\"}, # optional dependency\n  ]\nend\n```","ref":"ExAws.S3.html#module-installation"},{"type":"module","title":"Operations on AWS S3 - ExAws.S3","doc":"","ref":"ExAws.S3.html#module-operations-on-aws-s3"},{"type":"module","title":"Basic Operations - ExAws.S3","doc":"The vast majority of operations here represent a single operation on S3.\n\n#### Examples\n```\nS3.list_objects(\"my-bucket\") |> ExAws.request! #=> %{body: [list, of, objects]}\nS3.list_objects(\"my-bucket\") |> ExAws.stream! |> Enum.to_list #=> [list, of, objects]\n\nS3.put_object(\"my-bucket\", \"path/to/bucket\", contents) |> ExAws.request!\n```","ref":"ExAws.S3.html#module-basic-operations"},{"type":"module","title":"Higher Level Operations - ExAws.S3","doc":"There are also some operations which operate at a higher level to make it easier\nto download and upload very large files.\n\nMultipart uploads\n```\n\"path/to/big/file\"\n|> S3.Upload.stream_file\n|> S3.upload(\"my-bucket\", \"path/on/s3\")\n|> ExAws.request #=> {:ok, :done}\n```\nSee `ExAws.S3.upload/4` for options\n\nDownload large file to disk\n```\nS3.download_file(\"my-bucket\", \"path/on/s3\", \"path/to/dest/file\")\n|> ExAws.request #=> {:ok, :done}\n```","ref":"ExAws.S3.html#module-higher-level-operations"},{"type":"module","title":"More high level functionality - ExAws.S3","doc":"Task.async_stream makes some high level flows so easy you don't need explicit ExAws support.\n\nFor example, here is how to concurrently upload many files.\n\n```\nupload_file = fn {src_path, dest_path} ->\n  S3.put_object(\"my_bucket\", dest_path, File.read!(src_path))\n  |> ExAws.request!\nend\n\npaths = %{\"path/to/src0\" => \"path/to/dest0\", \"path/to/src1\" => \"path/to/dest1\"}\n\npaths\n|> Task.async_stream(upload_file, max_concurrency: 10)\n|> Stream.run\n```","ref":"ExAws.S3.html#module-more-high-level-functionality"},{"type":"module","title":"Bucket as host functionality - ExAws.S3","doc":"#### Examples\n```\nopts = [virtual_host: true, bucket_as_host: true]\n\nExAws.Config.new(:s3)\n|> S3.presigned_url(:get, \"bucket.custom-domain.com\", \"foo.txt\", opts)\n\n{:ok, \"https://bucket.custom-domain.com/foo.txt\"}\n```","ref":"ExAws.S3.html#module-bucket-as-host-functionality"},{"type":"module","title":"Configuration - ExAws.S3","doc":"The `scheme`, `host`, and `port` can be configured to hit alternate endpoints.\n\nFor example, this is how to use a local minio instance:\n\n```elixir\n# config.exs\nconfig :ex_aws, :s3,\n  scheme: \"http://\",\n  host: \"localhost\",\n  port: 9000\n```\n\nAn alternate `content_hash_algorithm` can be specified as well. The default is `:md5`. It may be necessary to change this when operating in a FIPS-compliant environment where MD5 isn't available, for instance. At this time, only `:sha256`, `:sha`, and `:md5` are supported by both Erlang and S3.\n\n``` elixir\n# config.exs\nconfig :ex_aws_s3, :content_hash_algorithm, :sha256\n```","ref":"ExAws.S3.html#module-configuration"},{"type":"function","title":"ExAws.S3.abort_multipart_upload/3","doc":"Abort a multipart upload","ref":"ExAws.S3.html#abort_multipart_upload/3"},{"type":"function","title":"ExAws.S3.calculate_content_header/1","doc":"","ref":"ExAws.S3.html#calculate_content_header/1"},{"type":"function","title":"ExAws.S3.complete_multipart_upload/4","doc":"Complete a multipart upload","ref":"ExAws.S3.html#complete_multipart_upload/4"},{"type":"function","title":"ExAws.S3.delete_all_objects/3","doc":"Delete all listed objects.\n\nWhen performed, this function will continue making `delete_multiple_objects`\nrequests deleting 1000 objects at a time until all are deleted.\n\nCan be streamed.","ref":"ExAws.S3.html#delete_all_objects/3"},{"type":"function","title":"Example - ExAws.S3.delete_all_objects/3","doc":"```\nstream = ExAws.S3.list_objects(bucket(), prefix: \"some/prefix\") |> ExAws.stream!() |> Stream.map(& &1.key)\nExAws.S3.delete_all_objects(bucket(), stream) |> ExAws.request()\n```","ref":"ExAws.S3.html#delete_all_objects/3-example"},{"type":"function","title":"ExAws.S3.delete_bucket/1","doc":"Delete a bucket","ref":"ExAws.S3.html#delete_bucket/1"},{"type":"function","title":"ExAws.S3.delete_bucket_cors/1","doc":"Delete a bucket cors","ref":"ExAws.S3.html#delete_bucket_cors/1"},{"type":"function","title":"ExAws.S3.delete_bucket_lifecycle/1","doc":"Delete a bucket lifecycle","ref":"ExAws.S3.html#delete_bucket_lifecycle/1"},{"type":"function","title":"ExAws.S3.delete_bucket_policy/1","doc":"Delete a bucket policy","ref":"ExAws.S3.html#delete_bucket_policy/1"},{"type":"function","title":"ExAws.S3.delete_bucket_replication/1","doc":"Delete a bucket replication","ref":"ExAws.S3.html#delete_bucket_replication/1"},{"type":"function","title":"ExAws.S3.delete_bucket_tagging/1","doc":"Delete a bucket tagging","ref":"ExAws.S3.html#delete_bucket_tagging/1"},{"type":"function","title":"ExAws.S3.delete_bucket_website/1","doc":"Delete a bucket website","ref":"ExAws.S3.html#delete_bucket_website/1"},{"type":"function","title":"ExAws.S3.delete_multiple_objects/3","doc":"Delete multiple objects within a bucket\n\nLimited to 1000 objects.","ref":"ExAws.S3.html#delete_multiple_objects/3"},{"type":"function","title":"ExAws.S3.delete_object/3","doc":"Delete an object within a bucket","ref":"ExAws.S3.html#delete_object/3"},{"type":"function","title":"ExAws.S3.delete_object_tagging/3","doc":"Remove the entire tag set from the specified object","ref":"ExAws.S3.html#delete_object_tagging/3"},{"type":"function","title":"ExAws.S3.download_file/4","doc":"Download an S3 object to a file.\n\nThis operation downloads multiple parts of an S3 object concurrently, allowing\nyou to maximize throughput.\n\nDefaults to a concurrency of 8, chunk size of 1MB, and a timeout of 1 minute.","ref":"ExAws.S3.html#download_file/4"},{"type":"function","title":"Streaming to memory - ExAws.S3.download_file/4","doc":"In order to use `ExAws.stream!/2`, the third `dest` parameter must be set to `:memory`.\nAn example would be like the following:\n\n    ExAws.S3.download_file(\"example-bucket\", \"path/to/file.txt\", :memory)\n    |> ExAws.stream!()\n\nNote that **this won't start fetching anything immediately** since it returns an Elixir `Stream`.\n\n#### Streaming by line\n\nStreaming by line can be done with `Stream.chunk_while/4`. Here is an example:\n\n    # Returns a stream which grabs chunks of data from S3 as specified in `opts`\n    # but processes the stream line by line. For example, the default chunk\n    # size of 1MB means requests for bytes from S3 will ask for 1MB sizes (to be downloaded)\n    # however each element of the stream will be a single line.\n    def generate_stream(bucket, file, opts \\\\ []) do\n      bucket\n      |> ExAws.S3.download_file(file, :memory, opts)\n      |> ExAws.stream!()\n      # Uncomment if you need to gunzip (and add dependency :stream_gzip)\n      # |> StreamGzip.gunzip()\n      |> Stream.chunk_while(\"\", &chunk_fun/2, &to_line_stream_after_fun/1)\n      |> Stream.concat()\n    end\n\n    def chunk_fun(chunk, acc) do\n      to_try = acc <> chunk\n      {elements, acc} = chunk_by_newline(to_try, \"\\n\", [], {0, byte_size(to_try)})\n      {:cont, elements, acc}\n    end\n\n    defp chunk_by_newline(_string, _newline, elements, {_offset, 0}) do\n      {Enum.reverse(elements), \"\"}\n    end\n\n    defp chunk_by_newline(string, newline, elements, {offset, length}) do\n      case :binary.match(string, newline, scope: {offset, length}) do\n        {newline_offset, newline_length} ->\n          difference = newline_length + newline_offset - offset\n          element = binary_part(string, offset, difference)\n\n          chunk_by_newline(\n            string,\n            newline,\n            [element | elements],\n            {newline_offset + newline_length, length - difference}\n          )\n        :nomatch ->\n          {Enum.reverse(elements), binary_part(string, offset, length)}\n      end\n    end\n\n    defp to_line_stream_after_fun(\"\"), do: {:cont, []}\n    defp to_line_stream_after_fun(acc), do: {:cont, [acc], []}","ref":"ExAws.S3.html#download_file/4-streaming-to-memory"},{"type":"function","title":"ExAws.S3.get_bucket_acl/1","doc":"Get bucket acl","ref":"ExAws.S3.html#get_bucket_acl/1"},{"type":"function","title":"ExAws.S3.get_bucket_cors/1","doc":"Get bucket cors","ref":"ExAws.S3.html#get_bucket_cors/1"},{"type":"function","title":"ExAws.S3.get_bucket_lifecycle/1","doc":"Get bucket lifecycle","ref":"ExAws.S3.html#get_bucket_lifecycle/1"},{"type":"function","title":"ExAws.S3.get_bucket_location/1","doc":"Get bucket location","ref":"ExAws.S3.html#get_bucket_location/1"},{"type":"function","title":"ExAws.S3.get_bucket_logging/1","doc":"Get bucket logging","ref":"ExAws.S3.html#get_bucket_logging/1"},{"type":"function","title":"ExAws.S3.get_bucket_notification/1","doc":"Get bucket notification","ref":"ExAws.S3.html#get_bucket_notification/1"},{"type":"function","title":"ExAws.S3.get_bucket_object_versions/2","doc":"Get bucket object versions","ref":"ExAws.S3.html#get_bucket_object_versions/2"},{"type":"function","title":"ExAws.S3.get_bucket_policy/1","doc":"Get bucket policy","ref":"ExAws.S3.html#get_bucket_policy/1"},{"type":"function","title":"ExAws.S3.get_bucket_replication/1","doc":"Get bucket replication","ref":"ExAws.S3.html#get_bucket_replication/1"},{"type":"function","title":"ExAws.S3.get_bucket_request_payment/1","doc":"Get bucket payment configuration","ref":"ExAws.S3.html#get_bucket_request_payment/1"},{"type":"function","title":"ExAws.S3.get_bucket_tagging/1","doc":"Get bucket tagging","ref":"ExAws.S3.html#get_bucket_tagging/1"},{"type":"function","title":"ExAws.S3.get_bucket_versioning/1","doc":"Get bucket versioning","ref":"ExAws.S3.html#get_bucket_versioning/1"},{"type":"function","title":"ExAws.S3.get_bucket_website/1","doc":"Get bucket website","ref":"ExAws.S3.html#get_bucket_website/1"},{"type":"function","title":"ExAws.S3.get_object/3","doc":"Get an object from a bucket","ref":"ExAws.S3.html#get_object/3"},{"type":"function","title":"Examples - ExAws.S3.get_object/3","doc":"```\nS3.get_object(\"my-bucket\", \"image.png\")\nS3.get_object(\"my-bucket\", \"image.png\", version_id: \"ae57ekgXPpdiVZLkYVWoTAGRhGJ5swt9\")\n```","ref":"ExAws.S3.html#get_object/3-examples"},{"type":"function","title":"ExAws.S3.get_object_acl/3","doc":"Get an object's access control policy","ref":"ExAws.S3.html#get_object_acl/3"},{"type":"function","title":"ExAws.S3.get_object_tagging/3","doc":"Get object tagging","ref":"ExAws.S3.html#get_object_tagging/3"},{"type":"function","title":"ExAws.S3.get_object_torrent/2","doc":"Get a torrent for a bucket","ref":"ExAws.S3.html#get_object_torrent/2"},{"type":"function","title":"ExAws.S3.head_bucket/1","doc":"Determine if a bucket exists","ref":"ExAws.S3.html#head_bucket/1"},{"type":"function","title":"ExAws.S3.head_object/3","doc":"Determine if an object exists","ref":"ExAws.S3.html#head_object/3"},{"type":"function","title":"ExAws.S3.initiate_multipart_upload/3","doc":"Initiate a multipart upload","ref":"ExAws.S3.html#initiate_multipart_upload/3"},{"type":"function","title":"ExAws.S3.list_buckets/1","doc":"List buckets","ref":"ExAws.S3.html#list_buckets/1"},{"type":"function","title":"ExAws.S3.list_multipart_uploads/2","doc":"List multipart uploads for a bucket","ref":"ExAws.S3.html#list_multipart_uploads/2"},{"type":"function","title":"ExAws.S3.list_objects/2","doc":"List objects in bucket\n\nCan be streamed.","ref":"ExAws.S3.html#list_objects/2"},{"type":"function","title":"Examples - ExAws.S3.list_objects/2","doc":"```\nS3.list_objects(\"my-bucket\") |> ExAws.request\n\nS3.list_objects(\"my-bucket\") |> ExAws.stream!\nS3.list_objects(\"my-bucket\", delimiter: \"/\", prefix: \"backup\") |> ExAws.stream!\nS3.list_objects(\"my-bucket\", prefix: \"some/inner/location/path\") |> ExAws.stream!\nS3.list_objects(\"my-bucket\", max_keys: 5, encoding_type: \"url\") |> ExAws.stream!\n```","ref":"ExAws.S3.html#list_objects/2-examples"},{"type":"function","title":"ExAws.S3.list_objects_v2/2","doc":"List objects in bucket\n\nCan be streamed.","ref":"ExAws.S3.html#list_objects_v2/2"},{"type":"function","title":"Examples - ExAws.S3.list_objects_v2/2","doc":"```\nS3.list_objects_v2(\"my-bucket\") |> ExAws.request\n\nS3.list_objects_v2(\"my-bucket\") |> ExAws.stream!\nS3.list_objects_v2(\"my-bucket\", delimiter: \"/\", prefix: \"backup\") |> ExAws.stream!\nS3.list_objects_v2(\"my-bucket\", prefix: \"some/inner/location/path\") |> ExAws.stream!\nS3.list_objects_v2(\"my-bucket\", max_keys: 5, encoding_type: \"url\") |> ExAws.stream!\n```","ref":"ExAws.S3.html#list_objects_v2/2-examples"},{"type":"function","title":"ExAws.S3.list_parts/4","doc":"List the parts of a multipart upload","ref":"ExAws.S3.html#list_parts/4"},{"type":"function","title":"ExAws.S3.options_object/5","doc":"Determine the CORS configuration for an object","ref":"ExAws.S3.html#options_object/5"},{"type":"function","title":"ExAws.S3.post_object_restore/4","doc":"Restore an object to a particular version","ref":"ExAws.S3.html#post_object_restore/4"},{"type":"function","title":"ExAws.S3.presigned_post/4","doc":"Generate a pre-signed post for an object.\n\nWhen option param `:virtual_host` is `true`, the bucket name will be used in\nthe hostname, along with the s3 default host which will look like -\n` .s3. .amazonaws.com` host.\n\nWhen option param `:s3_accelerate` is `true`, the bucket name will be used as\nthe hostname, along with the `s3-accelerate.amazonaws.com` host.\n\nWhen option param `:bucket_as_host` is `true`, the bucket name will be used as the full hostname.\nIn this case, bucket must be set to a full hostname, for example `mybucket.example.com`.\nThe `bucket_as_host` must be passed along with `virtual_host=true`","ref":"ExAws.S3.html#presigned_post/4"},{"type":"function","title":"ExAws.S3.presigned_url/5","doc":"Generate a pre-signed URL for an object.\nThis is a local operation and does not check whether the bucket or object exists.\n\nWhen option param `:virtual_host` is `true`, the bucket name will be used in\nthe hostname, along with the s3 default host which will look like -\n` .s3. .amazonaws.com` host.\n\nWhen option param `:s3_accelerate` is `true`, the bucket name will be used as\nthe hostname, along with the `s3-accelerate.amazonaws.com` host.\n\nWhen option param `:bucket_as_host` is `true`, the bucket name will be used as the full hostname.\nIn this case, bucket must be set to a full hostname, for example `mybucket.example.com`.\nThe `bucket_as_host` must be passed along with `virtual_host=true`\n\nOption param `:start_datetime` can be used to modify the start date for the presigned url, which\nallows for cache friendly urls.\n\nAdditional (signed) query parameters can be added to the url by setting option param\n`:query_params` to a list of `{\"key\", \"value\"}` pairs. Useful if you are uploading parts of\na multipart upload directly from the browser.\n\nSigned headers can be added to the url by setting option param `:headers` to\na list of `{\"key\", \"value\"}` pairs.","ref":"ExAws.S3.html#presigned_url/5"},{"type":"function","title":"Example - ExAws.S3.presigned_url/5","doc":"```\n:s3\n|> ExAws.Config.new([])\n|> ExAws.S3.presigned_url(:get, \"my-bucket\", \"my-object\", [])\n```","ref":"ExAws.S3.html#presigned_url/5-example"},{"type":"function","title":"ExAws.S3.put_bucket/3","doc":"Creates a bucket in the specified region","ref":"ExAws.S3.html#put_bucket/3"},{"type":"function","title":"ExAws.S3.put_bucket_acl/2","doc":"Update or create a bucket access control policy","ref":"ExAws.S3.html#put_bucket_acl/2"},{"type":"function","title":"ExAws.S3.put_bucket_cors/2","doc":"Update or create a bucket CORS policy","ref":"ExAws.S3.html#put_bucket_cors/2"},{"type":"function","title":"ExAws.S3.put_bucket_lifecycle/2","doc":"Update or create a bucket lifecycle configuration","ref":"ExAws.S3.html#put_bucket_lifecycle/2"},{"type":"function","title":"Live-Cycle Rule Format - ExAws.S3.put_bucket_lifecycle/2","doc":"%{\n      # Unique id for the rule (max. 255 chars, max. 1000 rules allowed)\n      id: \"123\",\n\n      # Disabled rules are not executed\n      enabled: true,\n\n      # Filters\n      # Can be based on prefix, object tag(s), both or none\n      filter: %{\n        prefix: \"prefix/\",\n        tags: %{\n          \"key\" => \"value\"\n        }\n      },\n\n      # Actions\n      # https://docs.aws.amazon.com/AmazonS3/latest/dev/intro-lifecycle-rules.html#intro-lifecycle-rules-actions\n      actions: %{\n        transition: %{\n          trigger: {:date, ~D[2020-03-26]}, # Date or days based\n          storage: \"\"\n        },\n        expiration: %{\n          trigger: {:days, 2}, # Date or days based\n          expired_object_delete_marker: true\n        },\n        noncurrent_version_transition: %{\n          trigger: {:days, 2}, # Only days based\n          storage: \"\"\n        },\n        noncurrent_version_expiration: %{\n          trigger: {:days, 2} # Only days based\n          newer_noncurrent_versions: 10\n        },\n        abort_incomplete_multipart_upload: %{\n          trigger: {:days, 2} # Only days based\n        }\n      }\n    }","ref":"ExAws.S3.html#put_bucket_lifecycle/2-live-cycle-rule-format"},{"type":"function","title":"ExAws.S3.put_bucket_logging/2","doc":"Update or create a bucket logging configuration","ref":"ExAws.S3.html#put_bucket_logging/2"},{"type":"function","title":"ExAws.S3.put_bucket_notification/2","doc":"Update or create a bucket notification configuration","ref":"ExAws.S3.html#put_bucket_notification/2"},{"type":"function","title":"ExAws.S3.put_bucket_policy/2","doc":"Update or create a bucket policy configuration","ref":"ExAws.S3.html#put_bucket_policy/2"},{"type":"function","title":"ExAws.S3.put_bucket_replication/2","doc":"Update or create a bucket replication configuration","ref":"ExAws.S3.html#put_bucket_replication/2"},{"type":"function","title":"ExAws.S3.put_bucket_request_payment/2","doc":"Update or create a bucket requestPayment configuration","ref":"ExAws.S3.html#put_bucket_request_payment/2"},{"type":"function","title":"ExAws.S3.put_bucket_tagging/2","doc":"Update or create a bucket tagging configuration","ref":"ExAws.S3.html#put_bucket_tagging/2"},{"type":"function","title":"ExAws.S3.put_bucket_versioning/2","doc":"Update or create a bucket versioning configuration","ref":"ExAws.S3.html#put_bucket_versioning/2"},{"type":"function","title":"Example - ExAws.S3.put_bucket_versioning/2","doc":"```\nExAws.S3.put_bucket_versioning(\n \"my-bucket\",\n \"  Enabled  \"\n)\n|> ExAws.request()\n```","ref":"ExAws.S3.html#put_bucket_versioning/2-example"},{"type":"function","title":"ExAws.S3.put_bucket_website/2","doc":"Update or create a bucket website configuration","ref":"ExAws.S3.html#put_bucket_website/2"},{"type":"function","title":"ExAws.S3.put_object/4","doc":"Create an object within a bucket","ref":"ExAws.S3.html#put_object/4"},{"type":"function","title":"ExAws.S3.put_object_acl/3","doc":"Create or update an object's access control policy","ref":"ExAws.S3.html#put_object_acl/3"},{"type":"function","title":"ExAws.S3.put_object_copy/5","doc":"Copy an object","ref":"ExAws.S3.html#put_object_copy/5"},{"type":"function","title":"ExAws.S3.put_object_tagging/4","doc":"Add a set of tags to an existing object","ref":"ExAws.S3.html#put_object_tagging/4"},{"type":"function","title":"Options - ExAws.S3.put_object_tagging/4","doc":"- `:version_id` - The versionId of the object that the tag-set will be added to.","ref":"ExAws.S3.html#put_object_tagging/4-options"},{"type":"function","title":"ExAws.S3.upload/4","doc":"Multipart upload to S3.\n\nHandles initialization, uploading parts concurrently, and multipart upload completion.","ref":"ExAws.S3.html#upload/4"},{"type":"function","title":"Uploading a stream - ExAws.S3.upload/4","doc":"Streams that emit binaries may be uploaded directly to S3. Each binary will be uploaded\nas a chunk, so it must be at least 5 megabytes in size. The `S3.Upload.stream_file`\nhelper takes care of reading the file in 5 megabyte chunks.\n```\n\"path/to/big/file\"\n|> S3.Upload.stream_file\n|> S3.upload(\"my-bucket\", \"path/on/s3\")\n|> ExAws.request! #=> :done\n```","ref":"ExAws.S3.html#upload/4-uploading-a-stream"},{"type":"function","title":"Options - ExAws.S3.upload/4","doc":"These options are specific to this function\n* See `Task.async_stream/5`'s `:max_concurrency` and `:timeout` options.\n  * `:max_concurrency` - only applies when uploading a stream. Sets the maximum number of tasks to run at the same time. Defaults to `4`\n  * `:timeout` - the maximum amount of time (in milliseconds) each task is allowed to execute for. Defaults to `30_000`.\n  * `:refetch_auth_on_request` - re-fetch the auth from the library config on each request in the upload process instead of using\n    the initial auth. Fixes an edge case uploading large files when using a strategy from `ex_aws_sts` that provides short lived tokens,\n    where uploads could fail if the token expires before the upload is completed. Defaults to `false`.\n\nAll other options (ex. `:content_type`) are passed through to\n`ExAws.S3.initiate_multipart_upload/3`.","ref":"ExAws.S3.html#upload/4-options"},{"type":"function","title":"ExAws.S3.upload_part/6","doc":"Upload a part for a multipart upload","ref":"ExAws.S3.html#upload_part/6"},{"type":"function","title":"ExAws.S3.upload_part_copy/8","doc":"Upload a part for a multipart copy","ref":"ExAws.S3.html#upload_part_copy/8"},{"type":"type","title":"ExAws.S3.acl_opt/0","doc":"","ref":"ExAws.S3.html#t:acl_opt/0"},{"type":"type","title":"ExAws.S3.acl_opts/0","doc":"","ref":"ExAws.S3.html#t:acl_opts/0"},{"type":"type","title":"ExAws.S3.amz_meta_opts/0","doc":"","ref":"ExAws.S3.html#t:amz_meta_opts/0"},{"type":"type","title":"ExAws.S3.canned_acl/0","doc":"","ref":"ExAws.S3.html#t:canned_acl/0"},{"type":"type","title":"ExAws.S3.customer_encryption_opts/0","doc":"","ref":"ExAws.S3.html#t:customer_encryption_opts/0"},{"type":"type","title":"ExAws.S3.delete_object_opt/0","doc":"","ref":"ExAws.S3.html#t:delete_object_opt/0"},{"type":"type","title":"ExAws.S3.delete_object_opts/0","doc":"","ref":"ExAws.S3.html#t:delete_object_opts/0"},{"type":"type","title":"ExAws.S3.download_file_opts/0","doc":"","ref":"ExAws.S3.html#t:download_file_opts/0"},{"type":"type","title":"ExAws.S3.encryption_opts/0","doc":"","ref":"ExAws.S3.html#t:encryption_opts/0"},{"type":"type","title":"ExAws.S3.expires_in_seconds/0","doc":"","ref":"ExAws.S3.html#t:expires_in_seconds/0"},{"type":"type","title":"ExAws.S3.get_object_opts/0","doc":"","ref":"ExAws.S3.html#t:get_object_opts/0"},{"type":"type","title":"ExAws.S3.get_object_response_opts/0","doc":"","ref":"ExAws.S3.html#t:get_object_response_opts/0"},{"type":"type","title":"ExAws.S3.grant/0","doc":"","ref":"ExAws.S3.html#t:grant/0"},{"type":"type","title":"ExAws.S3.grantee/0","doc":"","ref":"ExAws.S3.html#t:grantee/0"},{"type":"type","title":"ExAws.S3.hash_algorithm/0","doc":"The hashing algorithms that both S3 and Erlang support.\n\nhttps://docs.aws.amazon.com/AmazonS3/latest/userguide/checking-object-integrity.html\nhttps://www.erlang.org/doc/man/crypto.html#type-hash_algorithm","ref":"ExAws.S3.html#t:hash_algorithm/0"},{"type":"type","title":"ExAws.S3.head_object_opt/0","doc":"","ref":"ExAws.S3.html#t:head_object_opt/0"},{"type":"type","title":"ExAws.S3.head_object_opts/0","doc":"","ref":"ExAws.S3.html#t:head_object_opts/0"},{"type":"type","title":"ExAws.S3.initiate_multipart_upload_opt/0","doc":"","ref":"ExAws.S3.html#t:initiate_multipart_upload_opt/0"},{"type":"type","title":"ExAws.S3.initiate_multipart_upload_opts/0","doc":"","ref":"ExAws.S3.html#t:initiate_multipart_upload_opts/0"},{"type":"type","title":"ExAws.S3.list_objects_opts/0","doc":"","ref":"ExAws.S3.html#t:list_objects_opts/0"},{"type":"type","title":"ExAws.S3.list_objects_v2_opts/0","doc":"","ref":"ExAws.S3.html#t:list_objects_v2_opts/0"},{"type":"type","title":"ExAws.S3.presigned_post_opts/0","doc":"","ref":"ExAws.S3.html#t:presigned_post_opts/0"},{"type":"type","title":"ExAws.S3.presigned_post_result/0","doc":"","ref":"ExAws.S3.html#t:presigned_post_result/0"},{"type":"type","title":"ExAws.S3.presigned_url_opts/0","doc":"","ref":"ExAws.S3.html#t:presigned_url_opts/0"},{"type":"type","title":"ExAws.S3.put_object_copy_opts/0","doc":"","ref":"ExAws.S3.html#t:put_object_copy_opts/0"},{"type":"type","title":"ExAws.S3.put_object_opts/0","doc":"","ref":"ExAws.S3.html#t:put_object_opts/0"},{"type":"type","title":"ExAws.S3.storage_class/0","doc":"","ref":"ExAws.S3.html#t:storage_class/0"},{"type":"type","title":"ExAws.S3.storage_class_opt/0","doc":"","ref":"ExAws.S3.html#t:storage_class_opt/0"},{"type":"type","title":"ExAws.S3.upload_opt/0","doc":"","ref":"ExAws.S3.html#t:upload_opt/0"},{"type":"type","title":"ExAws.S3.upload_opts/0","doc":"","ref":"ExAws.S3.html#t:upload_opts/0"},{"type":"type","title":"ExAws.S3.upload_part_copy_opts/0","doc":"","ref":"ExAws.S3.html#t:upload_part_copy_opts/0"},{"type":"module","title":"ExAws.S3.Download","doc":"Represents an AWS S3 file download operation","ref":"ExAws.S3.Download.html"},{"type":"function","title":"ExAws.S3.Download.build_chunk_stream/2","doc":"","ref":"ExAws.S3.Download.html#build_chunk_stream/2"},{"type":"function","title":"ExAws.S3.Download.chunk_stream/2","doc":"","ref":"ExAws.S3.Download.html#chunk_stream/2"},{"type":"function","title":"ExAws.S3.Download.get_chunk/3","doc":"","ref":"ExAws.S3.Download.html#get_chunk/3"},{"type":"type","title":"ExAws.S3.Download.t/0","doc":"","ref":"ExAws.S3.Download.html#t:t/0"},{"type":"module","title":"ExAws.S3.Parsers","doc":"","ref":"ExAws.S3.Parsers.html"},{"type":"function","title":"ExAws.S3.Parsers.parse_all_my_buckets_result/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_all_my_buckets_result/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_bucket_object_versions/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_bucket_object_versions/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_complete_multipart_upload/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_complete_multipart_upload/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_initiate_multipart_upload/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_initiate_multipart_upload/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_list_multipart_uploads/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_list_multipart_uploads/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_list_objects/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_list_objects/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_list_parts/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_list_parts/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_object_tagging/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_object_tagging/1"},{"type":"function","title":"ExAws.S3.Parsers.parse_upload_part_copy/1","doc":"","ref":"ExAws.S3.Parsers.html#parse_upload_part_copy/1"},{"type":"module","title":"ExAws.S3.Upload","doc":"Represents an AWS S3 Multipart Upload operation.\n\nImplements `ExAws.Operation.perform/2`","ref":"ExAws.S3.Upload.html"},{"type":"module","title":"Examples - ExAws.S3.Upload","doc":"```\n\"path/to/big/file\"\n|> S3.Upload.stream_file\n|> S3.upload(\"my-bucket\", \"path/on/s3\")\n|> ExAws.request! #=> :done\n```\n\nSee `ExAws.S3.upload/4` for options","ref":"ExAws.S3.Upload.html#module-examples"},{"type":"function","title":"ExAws.S3.Upload.complete/3","doc":"","ref":"ExAws.S3.Upload.html#complete/3"},{"type":"function","title":"ExAws.S3.Upload.initialize/2","doc":"","ref":"ExAws.S3.Upload.html#initialize/2"},{"type":"function","title":"ExAws.S3.Upload.stream_file/2","doc":"Open a file stream for use in an upload.\n\nChunk size must be at least 5 MiB. Defaults to 5 MiB","ref":"ExAws.S3.Upload.html#stream_file/2"},{"type":"function","title":"ExAws.S3.Upload.upload_chunk/3","doc":"","ref":"ExAws.S3.Upload.html#upload_chunk/3"},{"type":"function","title":"ExAws.S3.Upload.upload_chunk!/3","doc":"Upload a chunk for an operation.\n\nThe first argument is a tuple with the binary contents of the chunk, and a\npositive integer index indicating which chunk it is. It will return this index\nalong with the `etag` response from AWS necessary to complete the multipart upload.","ref":"ExAws.S3.Upload.html#upload_chunk!/3"},{"type":"type","title":"ExAws.S3.Upload.t/0","doc":"","ref":"ExAws.S3.Upload.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}